//	==================================================================================	//
#ifndef _IEC60730_Class_B_H_
#define _IEC60730_Class_B_H_
//	==================================================================================	//

/*	==================================================================================	//
	PUBLIC - typedef, enum, union, struct ....... 
//	==================================================================================	*/
#define	d_iec60730_crc		0x3583

/* ************************************************************************************* //
	Brief		Go to reset chip when IEC60730 class B test failed.
// ************************************************************************************ */
void f_iec60730_go_reset( void);

/* ************************************************************************************* //
	Brief		The test of IEC60730 class B.
				BEWARE ......
				1) at STARTUP state will set << DI >>
				2) at STARTUP state will not save << IMF >>
// ************************************************************************************ */
void f_iec60730_class_b_startup( void);

/* ************************************************************************************* //
	Brief		The test of IEC60730 class B.
// ************************************************************************************ */
void f_iec60730_class_b_runtime( void);

/* ************************************************************************************* //
	Brief		The get result of IEC60730 class B.
	
	return		= unsigned char		= 0		= all passed
									= bit 7 = 1 = failed by testing self
									= bit 6 = 1 = failed by testing self
									= bit 5 = 1 = failed by testing self
									= bit 4 = 1 = failed by testing FLASH
									= bit 3 = 1 = failed by testing CLOCK
									= bit 2 = 1 = failed by testing SRAM
									= bit 1 = 1 = failed by testing GPR
									= bit 0 = 1 = failed by testing PC
// ************************************************************************************ */
unsigned char f_iec60730_get_result( void);

#endif
//	==================================================================================	//
