/* ======================================================================================================== //
// the process of IEC60730 Class B
// ======================================================================================================== */
#pragma section const			l_iec60730_class_b_flash_crc	d_iec60730_class_b_flash_crc_address
typedef union	{	unsigned short	buf;
					struct	{	unsigned short b1:8;
								unsigned short b0:8;
							}	byte;
					struct	{	unsigned short n3:4;
								unsigned short n2:4;
								unsigned short n1:4;
								unsigned short n0:4;
							}	nibble;
					struct	{	unsigned short b15:1;
								unsigned short b14:1;
								unsigned short b13:1;
								unsigned short b12:1;
								unsigned short b11:1;
								unsigned short b10:1;
								unsigned short b9:1;
								unsigned short b8:1;
								unsigned short b7:1;
								unsigned short b6:1;
								unsigned short b5:1;
								unsigned short b4:1;
								unsigned short b3:1;
								unsigned short b2:1;
								unsigned short b1:1;
								unsigned short b0:1;
							}	bit;
				}	unsigned_short;
				
static const unsigned_short	a_crc[] = { d_iec60730_crc,	0xffff };
#pragma section const

/* ======================================================================================================== //
// ======================================================================================================== */
static void f_iec60730_class_b_startup_flash( void)
{
	f_iec60730_class_b_runtime_flash();
}

/* ======================================================================================================== //
// ======================================================================================================== */
static void f_iec60730_class_b_runtime_flash( void)
{
	if ( r_iec60730.share.result.bit.flash == 0 )
	{
		{// init
			CRCCR		= 0x00;
			DICCR		= 0x00;
			CRCCR		= 0x01;
		}
		{// count
			{// 1st section
				{// set start from ....
					DICADR0 = 0x00;
					DICADR1 = 0x40;
					DICADR2 = 0x00;	// 0 = flash area
				}
				{// set count how many bytes
					DICCNT0 = 0x2c;
					DICCNT1 = 0xbf;
				}
				{// set init crc
					CRCDO0 = 0;
					CRCDO1 = 0;
				}
				{// get action
					DICCR = 0x01;	////////////// start count
					while(DICCR_BUSY);	////////// wait for DIC done
				}
				{// get answer back
					r_iec60730.share.buf[0] = CRCDO0;
					r_iec60730.share.buf[1] = CRCDO1;
				}
			}
			{// 2nd section
				{// set start from ....
					DICADR0 = 0x2e;
					DICADR1 = 0xff;
					DICADR2 = 0x00;	// 0 = flash area
				}
				{// set count how many bytes
					DICCNT0 = 0x02;
					DICCNT1 = 0x00;
				}
				{// set init crc
					CRCDO0 = r_iec60730.share.buf[0];
					CRCDO1 = r_iec60730.share.buf[1];
				}
				{// get action
					DICCR = 0x01;	////////////// start count
					while(DICCR_BUSY);	////////// wait for DIC done
				}
				{// get answer back
					r_iec60730.share.buf[0] = CRCDO0;
					r_iec60730.share.buf[1] = CRCDO1;
				}
			}
			{// 3rd section
				{// set start from ....
					DICADR0 = 0x2e;
					DICADR1 = 0xff;
					DICADR2 = 0x00;
				}
				{// set count how many bytes
					DICCNT0 = 0xd2;
					DICCNT1 = 0x00;
				}
				{// set init crc
					CRCDO0 = r_iec60730.share.buf[0];
					CRCDO1 = r_iec60730.share.buf[1];
				}
				{// get action
					DICCR = 0x01;	////////////// start count
					while(DICCR_BUSY);	////////// wait for DIC done
				}
				{// get answer back
					r_iec60730.share.buf[0] = CRCDO0;
					r_iec60730.share.buf[1] = CRCDO1;
				}
			}
		}
		{// finish
			DICCR_DICEN	= 0x00;
			CRCCR_CRCEN = 0x00;
		}
		{// Finial check
			if ( a_crc[0].byte.b0 != r_iec60730.share.buf[0] )
			{
				r_iec60730.share.result.bit.flash = 1;
			}
			if ( a_crc[0].byte.b1 != r_iec60730.share.buf[1] )
			{
				r_iec60730.share.result.bit.flash = 1;
			}
		}
	}
}

/* ======================================================================================================== //
// ======================================================================================================== */
